(define base-salary 10)
(define base-working-time 40)

; pay: number -> number
; pay computes the wages based on the working hours
(define pay
  (lambda (h)
    (+ (* h base-salary)
       (* (- h base-working-time) base-salary 1.5))))

(define normal-cost .75)
(define bulk-cost .5)
(define threshold 10)
; total-costs : number -> number
; produces the total costs of bulk orders of pens
(define total-costs
  (lambda (num-pens)
    (cond
      [(<= num-pens threshold) (* num-pens normal-cost)]
      [else (* num-pens bulk-cost)])))

; textual-mark : number -> string
; takes a number and produces a textual mark
(define textual-mark
  (lambda (n)
    (cond
      [(>= n 9) "excellent"]
      [(>= n 8) "very good"])))
    

; TESTS
;(string=? (textual-mark 8) "very good")
;(eq? (textual-mark 8) "very good")

;(start 300 300)
(define p1 (make-posn 50 150))
(define p2 (make-posn 50 50))
(define p3 (make-posn 150 50))

(define distance-to-origin
  (lambda (a-posn)
    (sqrt (+ (sqr (posn-x a-posn))
             (sqr (posn-y a-posn))))))

(define-struct result (team1 team2))
; a result is a structure: (make-result t1 t2)
; where t1 and t2 are numbers
(define r1 (make-result 2 2))
; TEMPLATE
; (define foo-result
; (lambda (a-result)
; .. (result-team1 a-result)..
; .. (result-team2 a-result)..

; toto : result -> string
; takes a result and produces a string representation
; of the result
(define toto
  (lambda (a-result)
    (cond
      [(> (result-team1 a-result)(result-team2 a-result)) "1"]
      [(= (result-team1 a-result)(result-team2 a-result)) "X"]
      [else "2"])))
      
      
; .. (result-team1 a-result)..
; .. (result-team2 a-result)..
  
