(define n!
  (lambda (n)
    (cond
      [(= n 1) 1]
      [else (* n (n! (- n 1)))])))

(define fib
  (lambda (x)
    (cond
      [(= x 1) 0]
      [(= x 2) 1]
      [else (+ (fib (- x 1)) (fib (- x 2)))])))
  
; DATA DEFINITION AND ANALYSIS
; a list-of-students is
; 1. the empty list
; 2. (cons s l-o-s) where s is a symbol and
;    l-o-s a list of symbols

; EXAMPLES
(define list1 (list 'Angelo 'Alex 'Giona 'Damiano 'Pasquale))
(define list2 empty)

; TEMPLATE
; (define foo-with-lists
; (lambda (a-s a-l-o-s)
; (cond
; [(empty? a-l-o-s) false]
; [else ..(first a-l-o-s)..(foo-with-lists (rest a-l-o-s))..]

(define areyouhere?
  (lambda (a-symbol a-list-of-symbols)
    (cond
      [(empty? a-list-of-symbols) false]
      [else (or (symbol=? (first a-list-of-symbols) a-symbol)
                 (areyouhere? a-symbol (rest a-list-of-symbols)))])))

; TESTS
(boolean=? true (areyouhere? 'Giona list1))

(define listX (list 30 40 50))
(define rate 50)

; TEMPLATE
; (define foo-list
; (lambda (a-list)
; (cond
; [(empty? a-list) .. ]
; [else (cons (first a-list) (foo-list (rest a-list)))]

(define hours->wages
  (lambda (a-list)
    (cond
      [(empty? a-list) empty]
      [else (cons (* rate (first a-list)) (hours->wages (rest a-list)))])))

(define sum-all
  (lambda (a-list)
    (cond
      [(empty? a-list) 0]
      [else (+ (first a-list) (sum-all (rest a-list)))])))

; TESTS
(equal? (hours->wages listX) (list 1500 2000 2500))
(= (sum-all (hours->wages listX)) 6000)