;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PROGRAMMING FUNDAMENTALS I - 2004
; MICHELE LANZA - FACULTY OF INFORMATICS - UNIVERSITY OF LUGANO, SWITZERLAND
; LECTURE 6 - LISTS AND NATURAL RECURSION
; WAGES EXAMPLE WITH STRUCTURES

; DATA ANALYSIS AND DESIGN
(define-struct worker (name hours))
; a worker is a structure: (make-worker n h) where
; n is a string and h is a number
; EXAMPLES
(define w1 (make-worker "Barney Gumble" 35))
(define w2 (make-worker "Ned Flanders" 45))
(define w3 (make-worker "Homer Simpson" 30))
; a list-of-workers is
; 1. empty
; 2. (cons w l-o-w) where w is a worker and l-o-w is a list of workers
; EXAMPLES
(define list-of-workers1 (list w1 w2 w3))
(define list-of-workers2 empty)
; CONSTANTS
(define rate 12)

; TEMPLATE
; (define foo-with-workers
; (lambda (a-list-of-workers)
; (cond
; [(empty? a-list-of-workers) empty]
; [else ..(first a-list-workers).. ..(foo-with-workers (rest a-list-of-workers))..]

; CONTRACT, PURPOSE, FUNCTION
; workers->wages : a-list-of-workers -> a-list-of-numbers
; takes a list of workers and produces a list of the wages they will get
(define workers->wages
  (lambda (a-list-of-workers)
    (cond
      [(empty? a-list-of-workers) empty]
      [else (cons (* rate (worker-hours (first a-list-of-workers))) 
                  (workers->wages (rest a-list-of-workers)))])))

; TESTS
(equal? (workers->wages list-of-workers1) (list 420 540 360))
(equal? (workers->wages list-of-workers2) empty)

; CONTRACT, PURPOSE, FUNCTION
; total-wages : a-list-of-numbers -> number
; sums the number in the list of numbers and produces the sum
(define total-wages
  (lambda (a-list-of-numbers)
    (cond
      [(empty? a-list-of-numbers) 0 ]
      [else (+ (first a-list-of-numbers) (total-wages (rest a-list-of-numbers)))])))

; TESTS
(= (total-wages (workers->wages list-of-workers1)) 1320)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; PROGRAMMING FUNDAMENTALS I - 2004
; MICHELE LANZA - FACULTY OF INFORMATICS - UNIVERSITY OF LUGANO, SWITZERLAND
; LECTURE 6 - LISTS AND NATURAL RECURSION
; INSERTION SORT EXAMPLE

; DATA ANALYSIS AND DESIGN
; a list-of-numbers is 1. empty or 
; 2. (cons n l-o-n) where n is a number and l-o-n a list of numbers

; TEMPLATE
; (define sort
; (lambda (a-list-of-numbers)
; (cond
; [(empty? a-list-of-numbers) ..]
; [else ..(first a-list-of-numbers)..(sort (rest a-list-of-numbers)).. 

; EXAMPLES
(define inputList1 (list 23 4 7 27))
(define outputList1 (list 4 7 23 27))
(define emptyList (list))

; AUXILIARY FUNCTIONS
; insert : number a-list-of-numbers -> a-list-of-numbers
; takes a number and a list of numbers and inserts the number in its appropriate position producing the sorted list
(define insert
  (lambda (a-number a-list-of-numbers)
    (cond
      [(empty? a-list-of-numbers) (cons a-number empty)]
      [else (cond
              [ (< a-number (first a-list-of-numbers)) (cons a-number a-list-of-numbers)]
              [else (cons (first a-list-of-numbers) (insert a-number (rest a-list-of-numbers)))])])))

; CONTRACT, PURPOSE, HEADER
; sort : list-of-numbers -> list-of-numbers
; takes a list of numbers and produces its sorted counterpart
(define sort
  (lambda (a-list-of-numbers)
    (cond
      [(empty? a-list-of-numbers) empty]
      [else (insert (first a-list-of-numbers) (sort (rest a-list-of-numbers)))])))

; TESTS
(equal? (sort inputList1) outputList1)